Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtStartDir.Text = Application.StartupPath
    End Sub

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        lstFiles.Items.Clear()
        MapDirectory(txtStartDir.Text, lstFiles)
    End Sub

    ' Thanks to Joshua Mcfarland.
    ' Search the directory subtree and make a list of the files.
    ' (In a real application, you would probably do something
    ' with the files other than putting them in a Listbox.)
    Sub MapDirectory(ByVal dir As String, ByVal lst As ListBox)
        With My.Computer.FileSystem
            ' List this directory's files.
            For Each file As String In .GetFiles(dir)
                'TODO: Do something with the file.
                lstFiles.Items.Add(file)
            Next file

            ' Search child directories.
            For Each folder As Object In .GetDirectories(dir)
                'TODO: Do something with the folder.
                MapDirectory(folder, lst)
            Next folder
        End With
    End Sub
End Class
